
/////////////////////////////////////////////////////////////////////////////
//
//             /
//      -  P  /  E  C  E  -
//           /                 mobile equipment
//
//              System Programs
//
//
// PIECE KERNEL : Ver 1.00
//
// Copyright (C)2001 AUQAPLUS Co., Ltd. / OeRSTED, Inc. all rights reserved.
//
// Coded by MIO.H (OeRSTED)
//
// Comments:
//
//  tbV̏/݂s܂B
//  tbVɂ͂̃vO͓܂̂
//  ͓̂RAM̓]ē܂B
//     fmacc1.c
//     fmacc2.c
//
//  v1.00 2001.11.09 MIO.H
//  v1.06 2001.11.24 MIO.H  ݎɃp[_E
//



#include <piece.h>
#include "pcekn.h"

#include <string.h>

int subFlashErase( volatile unsigned short *romp );
int subFlashWrite( volatile unsigned short *romp, unsigned char *memp, int len );


int pceFlashErase( void *romp )
{
	int ret;
	int oldspeed;
	volatile unsigned char *bp = iop_c;
	unsigned char saveNMI;

	ENTER_CS;

	saveNMI = bp[0x171];
	bp[0x170] = 0x80;
	bp[0x171] = 0x00;

	oldspeed = pceCPUSetSpeed( 3 );

	FRAMCOPY(V_FRAM4, fmacc1_code);

	ret = subFlashErase( (volatile unsigned short *)romp );

	FRAMCLEAR(V_FRAM4, fmacc1_code);

	pceCPUSetSpeed( oldspeed );

	bp[0x170] = 0x80;
	bp[0x171] = saveNMI;

	LEAVE_CS;

	return ret;
}

int pceFlashWrite( void *romp, const void *memp, int len )
{
	int ret = 0;
	int oldspeed;
	volatile unsigned char *bp = iop_c;
	unsigned char saveNMI;

	ENTER_CS;

	saveNMI = bp[0x171];
	bp[0x170] = 0x80;
	bp[0x171] = 0x00;

	oldspeed = pceCPUSetSpeed( 3 );

	FRAMCOPY(V_FRAM4, fmacc2_code);

	if ( len ) {
		len++;
		len >>= 1;
		ret = subFlashWrite( (volatile unsigned short *)romp, (unsigned char *)memp, len );
	}

	FRAMCLEAR(V_FRAM4, fmacc2_code);

	pceCPUSetSpeed( oldspeed );

	bp[0x170] = 0x80;
	bp[0x171] = saveNMI;

	LEAVE_CS;

	return ret;
}


void InitFlashAcc( void )
{
	pceVectorSetKs( KSNO_FlashErase, pceFlashErase );
	pceVectorSetKs( KSNO_FlashWrite, pceFlashWrite );
}


