
/////////////////////////////////////////////////////////////////////////////
//
//             /
//      -  P  /  E  C  E  -
//           /                 mobile equipment
//
//              System Programs
//
//
// PIECE KERNEL : Ver 1.00
//
// Copyright (C)2001 AUQAPLUS Co., Ltd. / OeRSTED, Inc. all rights reserved.
//
// Coded by MIO.H (OeRSTED)
//
// Comments:
//
//  bot̂{Iȃn[hEGȀs܂B
//
//  v1.00 2001.11.09 MIO.H
//  v1.06 2001.11.24 MIO.H pceCPUSetSpeed ɖ߂lݒ
//  v1.07 2001.11.28 MIO.H USB荞݃x6ɕύX
//


#include <piece.h>
#include "pcekn.h"


typedef struct tagCPUSPDTBL {
	unsigned char clk;
	unsigned char lcd;
	unsigned short area9;
	unsigned short area7;
	unsigned short area4;
} CPUSPDTBL;

//#define CPUSPDINFO(a,b,c,d,e) { 0x27+(a<<6), (b), 0x6000+c, d, 0x1100+e }
#define CPUSPDINFO(a,b,c,d,e) { 0x27+(a<<6), 0x80+(b<<4), 0x6000+c, d, 0x1100+e }

const CPUSPDTBL cpuspdtbl[4] = {
	CPUSPDINFO( 0,   0, 0x12, 0x24, 0x12 ), //
	CPUSPDINFO( 1,   0, 0x12, 0x22, 0x12 ), //
	CPUSPDINFO( 2,   1, 0x11, 0x21, 0x11 ), //
	CPUSPDINFO( 3,   2, 0x11, 0x21, 0x11 ), //
};


//!///// Piece Kernel Service API Reference
//! *v1.06+
//! 
//!  pceCPUSetSpeed
//! 
//! CPȖxݒ肵܂
//!	
//!	int pceCPUSetSpeed(
//!			int speed	// 0 = ~1, 1 = ~1/2, 2 = ~1/4, 3 = ~1/8
//!			)
//!
//!	߂lFȑO̐ݒl
//!
//! CPUxxقǏd͓Iɂ͗LɂȂ܂B
//! Aۂ2,3w肵ĂAʏ̎gpł
//! ȓd͏コقǌʂ͂܂B
//! 
//! ܂A2,3 ł LCD ̓]ۏ؂܂B
//! 
//! LlA܂dlύXɑΉł悤
//! 
//! CPU_SPEED_NORMAL  (x1)
//! CPU_SPEED_HALF    (x1/2)
//! 
//! gƂ𐄏܂B
//! 
//! 

int pceCPUSetSpeed( int speed )
{
	volatile unsigned char *bp = iop_c;
	volatile unsigned short *sp = iop_s;
	int oldspeed;

	const CPUSPDTBL *csp = cpuspdtbl + speed;

	ENTER_CS;

	oldspeed = (bp[0x180]>>6);

	bp[0x19e] = 0x96;			//	܂Ȃ
	bp[0x180] = csp->clk;		//	CPUNbN x1 24MHz
//	bp[0x19e] = 0x96;			//	܂Ȃ
//	bp[0x190] |= 8;

	sp[0x8126/2] = csp->area9;	// GA 10-9 (10:ROM)
	sp[0x8128/2] = csp->area7;	// GA 8-7  (8bit 8:LCD 7:USB)
								// USB Rg[̓TCN^C >500ns
	sp[0x812a/2] = csp->area4;	// GA 6 : 5-4 (4:SRAM)

	//bp[0x179] = csp->lcd;	// 8rbg^C} ch5 [hlݒ

	bp[0x145] = csp->lcd;	// 8rbg^C} ch5 vXP[I

	LEAVE_CS;

	return oldspeed;
}





void InitHard( unsigned long trap_table_adrs )
{
	volatile unsigned char *bp = iop_c;
	volatile unsigned short *sp = iop_s;
	volatile unsigned long *wp = iop_w;
	unsigned char a;

	// v^C}
	bp[0x151] = 1;				// v^C}Run/Stop

	//{
	//	volatile unsigned short *memp = (volatile unsigned short *)0x100000;
	//	unsigned short mark = 0x55aa;
	//	*memp = mark;
	//	if ( *memp != mark ) {
			sp[0x812e/2] = 0x0008;		//	#BSL 
	//	}
	//}

	bp[0x19e] = 0x96;			//	܂Ȃ
	bp[0x180] = 0x27+(3<<6);	//	CPUNbN x1/8

	bp[0x812d] = 0x59;			//	܂Ȃ
	wp[0x8134/4] = (unsigned long)trap_table_adrs;	// gbve[u̐擪ݒ

	sp[0x8126/2] = 0x6012;		// GA 10-9 (10:ROM)
	sp[0x8128/2] = 0x0024;		// GA 8-7  (8bit 8:LCD 7:USB)
								// USB Rg[̓TCN^C >500ns
	sp[0x812a/2] = 0x1112;		// GA 6 : 5-4 (4:SRAM)

	sp[0x8124/2] = 0x0077;		// GA 12-11 (11:for wait)

	bp[0x813a] = 8;				// BCLKIWX^

	a = bp[0x2d1];				// P00-07 ̋N̏

	bp[0x2d1] = a & 0x80;		// P00 0
								// P01 0
								// P02 0
								// P03 0 LED 0:ON 1:OFF
								// P04 0
								// P05 0 LED 0:ON 1:OFF
								// P06 0
								// P07 ? CLK-SEL 0:48M 1:24M
	bp[0x2d9] = 0x83;			// P20 1 LCD-IF CSB
								// P21 1 LCD-IF RS
								// P22 0
								// P23 0 Audio
								// P24 0 Audio(resv.)
								// P25 0
								// P26 0 USB-CLK(6MHz)
								// P27 1 IR-Tx
	bp[0x2dd] = 0x01;			// P30 1 DC-Power      0:USB      1:BATT
								// P31 0 Amp-Power     0:ON       1:OFF
								// P32 0 ( SRDY3 )
								// P33 0 LCD-Reset     0:RES      1:RUN
								// P34 0 IR-Power      0:OFF      1:ON
								// P35 0 DC-Power2     0:BATT-USB 1:BATT only

	bp[0x2d2] = 0xff;			// P00-07 o͂
	bp[0x2da] = 0xf3;			// P20,21,24-27 o͂
	bp[0x2de] = 0x3b;			// P30,31,33-35 o͂

	// ׂĂ̊荞݋֎~

	wp[0x270/4] = 0;
	wp[0x274/4] = 0;

	bp[0x29f] = 0x06;			// 荞ݗvtÔ RD/WR

	// `FbNp
	while ( 1 ) {
		if ( bp[0x2c1] & 0x08 ) break; // D{^ꂽ break;
		if ( bp[0x153] & 0x20 ) {
			bp[0x2d1] |= 0x28;
		}
		else {
			bp[0x2d1] &= ~0x28;
		}
		pdwait(1000);
	}
}




void InitHard2( void )
{
	volatile unsigned char *bp = iop_c;
	volatile unsigned short *sp = iop_s;
	//volatile unsigned long *wp = iop_w;
#if 0
	// v^C}

	bp[0x151] = 1;				// v^C}Run/Stop
	bp[0x152] = 0x63;			// v^C} 1Hz 荞ݗvI
	bp[0x26b] = 6;				// v^C} 荞݃vCIeB
	bp[0x277] = 2;				// v^C} 荞݃Cl[u
#endif
#if 1
	// USBC^[tF[Xp P26  6MHz ̃NbN

	bp[0x14b] = 8+0;					// 16bit^C}4 NbN 1/1
	sp[0x81a0/2] = ((clkp1+1)>>1)-1;	// 16bit^C}4 RyAf[^A
	sp[0x81a2/2] = clkp1-1;				// 16bit^C}4 RyAf[^B
	bp[0x81a6] = 7;						// 16bit^C}4 

	bp[0x2d8] = 0x40;			// P26  TM4 o͂

	// USBC^[tF[Xp INT_N 荞 (K51)

	bp[0x2c6] = 0x04;			// |[g͊荞1 ͑I (FTP1=K51)
	bp[0x2c8] = 0x00;			// |[g͊荞1 ɐI
	bp[0x2c9] = 0x00;			// |[g͊荞1 GbW/xI

	bp[0x260] = 0x60;			// |[g͊荞1 vCIeB (FTP1=6)
	bp[0x270] = 0x02;			// |[g͊荞1 
#endif

	pceVectorSetKs( KSNO_CPUSetSpeed, pceCPUSetSpeed );
}



void GetSysClock( void )
{
	volatile unsigned char *bp = iop_c;
	volatile unsigned short *sp = iop_s;
	unsigned long a;

	bp[0x147] = 8+4;			// 16bit^C}0 NbN 1/64
	sp[0x8180/2] = 32768-1;		// 16bit^C}0 RyAf[^A
	sp[0x8182/2] = 65536-1;		// 16bit^C}0 RyAf[^B
	bp[0x8186] = 3;				// 16bit^C}0 

	for ( a = 0; a < 2; a++ ) {
		while ( bp[0x153] & 0x08 );
		while ( !(bp[0x153] & 0x08) );
	}

	a = sp[0x8184/2];
	while ( bp[0x153] & 0x08 );
	a = ( sp[0x8184/2] - a ) & 0xffff;

	bp[0x8186] = 0;				// 16bit^C}0 

#if 0
	system_info.sys_clock = a*1000;
	clkp1 = 4; // 6*4 = 24M
	clkp2 = 2; // 6 * 2**2 = 24M
#else
	// 24MHz 11720

	a *= 1342;
	a += 32768;

	a>>=16;

	system_info.sys_clock = a * 100000;

	clkp1 = (a+5) / 60;		// 6Mn{H 1 2 3 4 5 6 7 8
	clkp2 = 0;
	a = clkp1;

	while ( 1 ) {			// 6M:0  12M:1  24M:2  48M:3
		if ( !(a>>=1) ) break;
		clkp2++;
	}
#endif

	if ( clkp1 < 5 ) {
		bp[0x19e] = 0x96;			//	܂Ȃ
		bp[0x180] = 0x27+(0<<6);	//	CPUNbN x1
	}
	else {
		bp[0x19e] = 0x96;			//	܂Ȃ
		bp[0x180] = 0x27+(1<<6);	//	CPUNbN x1/2

		sp[0x8126/2] = 0x6011;		// GA 10-9 (10:ROM)
		sp[0x8128/2] = 0x0012;		// GA 8-7  (8bit 8:LCD 7:USB)
									// USB Rg[̓TCN^C >500ns
		sp[0x812a/2] = 0x1111;		// GA 6 : 5-4 (4:SRAM)
	}
}


