
/////////////////////////////////////////////////////////////////////////////
//
//             /
//      -  P  /  E  C  E  -
//           /                 mobile equipment
//
//              System Programs
//
//
// PIECE KERNEL : Ver 1.00
//
// Copyright (C)2001 AUQAPLUS Co., Ltd. / OeRSTED, Inc. all rights reserved.
//
// Coded by MIO.H (OeRSTED)
//
// Comments:
//
//  q[v̈̃}l[W[łB
//
//  v1.03 2001.11.20 MIO.H
//  v1.19 2003.02.14 N.SAWA AllocHEAPMEM()̕sC
//

#include <piece.h>
#include "pcekn.h"



static void heapbroken( HEAPMEM *phm )
{
	APIErr( (unsigned long)phm, PCEKN_ERR_HEAP_BROKEN );
}

static void SetHEAPMEM( HEAPMEM *phm, int owner, void *chain )
{
	phm->mark = HEAPMEMMK;
	phm->owner = owner;
	phm->chain = chain;
}

static void CombineFreeHEAPMEM( HEAPMEM *phm )
{
	HEAPMEM *phm0 = phm;

	phm = phm->chain;

	while ( phm ) {
		if ( phm->mark != HEAPMEMMK ) heapbroken( phm );
		if ( phm->owner ) break;
		phm = phm->chain;
		phm0->chain = phm;
	}
}

static void AllocHEAPMEM( HEAPMEM *phm1, unsigned long size, unsigned long size1 )
{
	if ( size1 > size+sizeof(HEAPMEM) ) { // 2003.02.14 N.SAWA
		HEAPMEM *phm2 = phm1->chain;
		SetHEAPMEM( phm1, HMO_DEFAULT_USER, ((unsigned char *)phm1)+size );
		SetHEAPMEM( phm1->chain, 0, phm2 );
		CombineFreeHEAPMEM( phm1->chain );
	}
	else {
		phm1->owner = HMO_DEFAULT_USER;
	}
}

//!///// Piece Kernel Service API Reference
//!	*v1.06
//!	
//!	 pceHeapAlloc
//!	
//!	q[v̈蓖Ă܂B
//!	
//!	void *pceHeapAlloc(
//!			unsigned long size	// 蓖Ă̈̑傫
//!			);
//!	
//!	߂l : NULL(0)  : 蓖Ďs
//!	       : ȊO : 蓖Ăq[v̈ւ̃|C^
//!	
//!	蓖Ă|C^̃AhX́AO[h(4oCg)E
//!	ACgĂ܂B
//!	

void *pceHeapAlloc( unsigned long size0 )
{
	HEAPMEM *phm = heaptop;
	HEAPMEM *phm1 = NULL;
	unsigned long size1 = 0xffffffff;

	size0 = ((size0 + sizeof(HEAPMEM) + 3) & ~3);	// 4̔{ɐ

	while ( phm ) {
		if ( phm->mark != HEAPMEMMK ) heapbroken( phm );
		if ( !phm->owner ) {
			unsigned long size = (unsigned long)phm->chain - (unsigned long)phm;
			if ( size >= size0 && size < size1 ) {
				size1 = size;
				phm1 = phm;
			}
		}
		phm = phm->chain;
	}

	if ( phm1 ) {
		AllocHEAPMEM( phm1, size0, size1 );
		phm1 = (HEAPMEM *)(((unsigned long)phm1)+sizeof(HEAPMEM));
	}

	return phm1;
}

//!///// Piece Kernel Service API Reference
//!	*v1.06
//!	
//!	 pceHeapFree
//!	
//!	蓖čς݂̃q[v̈܂B
//!	
//!	int pceHeapFree(
//!			void *memp 	// 蓖čς݂̃q[v̈ւ̃|C^
//!			);
//!	
//!	߂l : 0        : 
//!	       : ȊO : s
//!	
//!	蓖čς݂łȂ|C^nꂽꍇAɎs܂B
//!	
//!	

int pceHeapFree( void *memp )
{
	HEAPMEM *phm = heaptop;
	HEAPMEM *phms = (HEAPMEM *)(((unsigned long)memp)-sizeof(HEAPMEM));
	HEAPMEM *phmb = phm;

	while ( phm ) {
		if ( phm->mark != HEAPMEMMK ) heapbroken( phm );
		if ( phm->owner && phm == phms ) break;
		phmb = phm;
		phm = phm->chain;
	}

	if ( !phm ) return 1;	// si͂܂j

	phm->owner = 0;

	if ( !phmb->owner ) CombineFreeHEAPMEM( phmb );
	else CombineFreeHEAPMEM( phm );

	return 0; // 
}

//!///// Piece Kernel Service API Reference
//!	*v1.06
//!	
//!	 pceHeapRealloc
//!	
//!	蓖čς݂̃q[v̈̑傫ύX܂B
//!	
//!	int pceHeapRealloc(
//!			void *memp 			// 蓖čς݂̃q[v̈ւ̃|C^
//!			unsigned long size	// V̈̑傫
//!			
//!			);
//!	
//!	߂l : 0        : 
//!	       : ȊO : s
//!	
//!	蓖čς݂łȂ|C^nꂽꍇAɎs܂B
//!	
//!	q[v蓖ẴASYÄg傷ւ
//!	傫ύX͎s\̂ŒӂĂB
//!	

int pceHeapRealloc( void *memp, unsigned long size )
{
	HEAPMEM *phm = heaptop;
	HEAPMEM *phms = (HEAPMEM *)(((unsigned long)memp)-sizeof(HEAPMEM));
	unsigned long oldsize;

	while ( phm ) {
		if ( phm->mark != HEAPMEMMK ) heapbroken( phm );
		if ( phm->owner && phm == phms ) break;
		phm = phm->chain;
	}

	if ( !phm ) return 1;	// si͂܂j

	size = ((size + sizeof(HEAPMEM) + 3) & ~3);	// 4̔{ɐ
	if ( !size ) size = 4;

	oldsize = (unsigned long)phm->chain - (unsigned long)phm;

	if ( oldsize < size ) {			// Heap 𑝂₳ȂƂȂ
		unsigned long n = size - oldsize;
		unsigned long n2;
		HEAPMEM *phm2 = phm->chain;
		if ( phm2->owner ) return 2; // s(ɋ󂫂Ȃ)
		n2 = (unsigned long)phm2->chain - (unsigned long)phm2;
		if ( n2 < n ) return 3;  // s(ɋ󂫂Ȃ)
		AllocHEAPMEM( phm2, n, n2 );
		SetHEAPMEM( phm, HMO_DEFAULT_USER, phm2->chain );
	}
	else if ( oldsize > size ) {	// Heap 炳ȂƂȂ
		AllocHEAPMEM( phm, size, oldsize );
	}

	return 0; // 
}

//!///// Piece Kernel Service API Reference
//!	*v1.06
//!	
//!	 pceHeapGetMaxFreeSize
//!	
//!	蓖ăq[v̈̂̍ő̑傫擾܂B
//!	
//!	int pceHeapGetMaxFreeSize( void );
//!	
//!	߂l : 蓖ăq[v̈̂̍ő̑傫
//!	
//!	߂l 0 ̏ꍇ́A̖蓖Ẵq[v̈͂܂B
//!	
//!	

int pceHeapGetMaxFreeSize( void )
{
	HEAPMEM *phm = heaptop;
	unsigned long size1 = 0;

	while ( phm ) {
		if ( phm->mark != HEAPMEMMK ) heapbroken( phm );
		if ( !phm->owner ) {
			unsigned long size = (unsigned long)phm->chain - (unsigned long)phm - sizeof(HEAPMEM);
			if ( size1 < size ) {
				size1 = size;
			}
		}
		phm = phm->chain;
	}

	return size1;
}

void ResetHeap( void *memp )
{
	heaptop = (HEAPMEM *)memp;
	if ( heaptop ) {
		SetHEAPMEM( heaptop, 0, system_info.sram_end-sizeof(HEAPMEM) );
		SetHEAPMEM( heaptop->chain, HMO_SYSTEM, NULL );
	}
}


void InitHeapman( void )
{
#ifdef __PCEKN__
	pceVectorSetKs( KSNO_HeapAlloc, pceHeapAlloc );
	pceVectorSetKs( KSNO_HeapFree, pceHeapFree );
	pceVectorSetKs( KSNO_HeapRealloc, pceHeapRealloc );
	pceVectorSetKs( KSNO_HeapGetMaxFreeSize, pceHeapGetMaxFreeSize );
#endif //#ifdef __PCEKN__
}

