
/////////////////////////////////////////////////////////////////////////////
//
//             /
//      -  P  /  E  C  E  -
//           /                 mobile equipment
//
//              System Programs
//
//
// PIECE KERNEL : Ver 1.00
//
// Copyright (C)2001-2002 AUQAPLUS Co., Ltd. / OeRSTED, Inc. all rights reserved.
//
// Coded by MIO.H (OeRSTED)
//
// Comments:
//
//  ԊOʐM֘ȀłB
//
//  v1.00 2001.11.09 MIO.H
//  v1.15 2002.01.04 MIO.H	ʐMG[΍􁕍
//  v1.16 2002.01.07 MIO.H	Ex,Pulse[hǉ
//  v1.17 2002.01.10 MIO.H	
//



#include <piece.h>
#include "pcekn.h"
#include "string.h"

// gg߂16rbg^C}[̒萔
// 24000 / 633 = 37.9kHz
#define IRCNT (633)

#define IRBC1 (12)
#define IRBC2 (8)


// crc32.c ({ unsigned long)
extern unsigned char crctable[];

typedef struct tagIRWK {
	unsigned char *pData;
	unsigned short tcnt;
	unsigned short tocnt;
	unsigned char pos;
	unsigned char len;
	unsigned char bcnt;
	unsigned char dat;
	unsigned char leader;
	union {
		void (*rx)( int flag, unsigned short time );
		int (*tx)( int flag );
	} proc;
	union {
		int (*rx)( int len );
		int (*tx)( void );
	} end;
} IRWK;

//static
IRWK irwk;

//static unsigned short IRtime[2];



// IRM荞
//
extern void irr_isr(void);

void irr_isr00(void)
{
	asm	("irr_isr:");
	INT_BEGIN2;
	{
		volatile unsigned char *bp = iop_c;
		volatile unsigned short *sp = iop_s;
		unsigned short a;

		a = sp[0x81ac/2];				// 16bit^C}5 JEgf[^
		sp[0x81a8/2] = a + irwk.tocnt;	// 16bit^C}5 RyAf[^A

		bp[0x2c8] ^= 0x04;				// |[g2 ɐI
		bp[0x280] &= ~0x04;				// 荞݃NA

		irwk.proc.rx( ((bp[0x2c8] >> 2)^1) & 1, a );
	}
	INT_END2;
}

// IRM荞 (^CAEg)
//
extern void irr2_isr(void);

void irr2_isr00(void)
{
	asm	("irr2_isr:");
	INT_BEGIN2;
	{
		volatile unsigned char *bp = iop_c;
		volatile unsigned short *sp = iop_s;
		unsigned short a;

		a = sp[0x81ac/2];				// 16bit^C}5 JEgf[^
		sp[0x81a8/2] = a + irwk.tocnt;	// 16bit^C}5 RyAf[^A

		bp[0x284] &= ~0x80;				// 荞݃NA

		irwk.proc.rx( 2, a );
	}
	INT_END2;
}

// IRM荞
//
extern void irt_isr(void);

void irt_isr00(void)
{
	asm	("irt_isr:");
	INT_BEGIN2;
	{
		volatile unsigned char *bp = iop_c;
		IRWK *piw = &irwk;
	
		bp[0x284] &= ~0x80;	// 荞݃NA
		if ( !--piw->tcnt ) {
			if ( ( ++piw->bcnt & 1 ) ) {
				bp[0x2d8] |= 0x80;		// P27  TM5 o͂Ɂyz
			}
			else {
				bp[0x2d9] |= 0x80;		// P27  1
				bp[0x2d8] &= ~0x80;		// P27  m[} o͂Ɂyz
			}
			piw->tcnt = piw->proc.tx( piw->bcnt & 1 );
		}
	}
	INT_END2;
}


static void RxBit( int flag, unsigned short a )
{
	IRWK *piw = &irwk;
	unsigned n = (a - piw->tcnt) & 0xffff;

	if ( !(flag & 1) ) return;

	n -= ((IRCNT*(IRBC1*2-IRBC2/2))/16);
	n /= ((IRCNT*IRBC2)/16);
//#ifndef __PCEKN__
//	if ( n < 128 ) ((unsigned short *)(0x1000))[n]++;
//#endif
	piw->dat >>= 2;
	piw->dat |= (n<<6);

	if ( piw->leader & 1 ) {
		piw->bcnt++;
		if ( n != 4 ) {
			if ( n < 4 && piw->bcnt >= 8 ) {
				piw->bcnt = 3;
				piw->leader &= ~1;
			}
			else {
				piw->bcnt = 0;
			}
		}
	}
	else {
		if ( n >= 4 ) goto _end_rx;
		if ( !--piw->bcnt ) {
			if ( piw->pos < piw->len ) {
				piw->bcnt = 4;
				*piw->pData++ = piw->dat ^ crctable[4+(piw->pos<<2)];
				piw->pos++;
			}
			if ( piw->pos >= piw->len ) {
_end_rx:		// I
				if ( !piw->end.rx || !piw->end.rx(piw->pos) ) {
					pceIRStop();
				}
			}
		}
	}

	piw->tcnt = a;
}


int TxBit( int flag )
{
	IRWK *piw = &irwk;
	int retv = IRBC1;

	if ( piw->leader & 1 ) {
		if ( piw->bcnt >= 16*2 ) {
			piw->leader &= ~1;
			goto _tx_start;
		}
		if ( !(flag & 1) ) retv = IRBC1+IRBC2*4;
	}
	else {
		if ( piw->bcnt >= 4*2 ) {
_tx_start:
			if ( piw->pos < piw->len ) {
				piw->bcnt = 0;
				piw->dat = *piw->pData++ ^ crctable[4+(piw->pos<<2)];
				piw->pos++;
			}
			else {
				if ( piw->bcnt >= 12*2 ) {
					// I
					if ( !piw->end.tx || !piw->end.tx() ) {
						pceIRStop();
					}
					return 0;
				}
				if ( !(piw->bcnt & 3) ) {
					retv = IRBC1+IRBC2*4;
				}
				return retv;
			}
		}
		if ( !(flag & 1) ) {
			static const unsigned char txtbl[4] = {
				IRBC1,
				IRBC1+IRBC2,
				IRBC1+IRBC2*2,
				IRBC1+IRBC2*3,
			};
			retv = txtbl[piw->dat & 3];
			piw->dat >>= 2;
		}
	}

	return retv;
}




//!///// Piece Kernel Service API Reference
//! 
//!  pceIRStartRx
//! 
//! ԊOf[^PubN͂܂B
//! 
//! void pceIRStartRx(
//! 	unsigned char *pData,	// Mf[^i[obt@̃|C^
//! 	int len					// obt@(1`255)
//! 	);
//! 
//! ߂lFȂ
//! 
//! mode  0, callback  NULL Ƃ pceIRStartRxEx() ĂԂ̂ƓłB
//! 

void pceIRStartRx( unsigned char *pData, int len )
{
	asm( "xld.w	%r14,0" );
	asm( "xld.w	%r15,0" );
	asm( "xjp	pceIRStartRxEx" );
}


//!///// Piece Kernel Service API Reference
//! *v1.17
//!  pceIRStartRxEx
//! 
//! ԊOf[^PubN͂܂B
//! 
//! void pceIRStartRxEx(
//! 		unsigned char *pData,		// Mf[^i[obt@̃|C^
//! 		int len,					// obt@(1`255)
//! 		int mode,					// \ K0ɂĂ
//! 		int (*callback)(int rlen)	// IR[obN֐
//! 		);
//! 
//! ߂lFȂ
//! 
//! ͔񓯊֐łB͂ɖ߂܂B
//!
//! ͎̊̂Q̕@Œm邱Ƃo܂B
//!
//! * callback  NULL ̎
//! pceIRGetStat() ɂăXe[^XɂȂƂmF܂B
//! ̏ꍇAŎIɃftHg̎M~s܂B
//! 
//! * callback  NULL ȊO̎
//! w肳ꂽR[obN֐Ăяo邱ƂŊmF܂B
//!  rlen ͎MoCgłB
//! R[obN֐ 0 ԂꍇAIɃftHg
//! M~s܂B
//! 1 Ԃꍇ pceIRStop() Kvɉđ̐ԊOAPIĂяo
//! ]ԂύXĂB
//! 
//! R[obN͊荞ݏ̓Ăяo܂̂
//! ӂĎgpĂBpceTimerSetCallback() QƁB
//! 
//! R[obNŎgpł API  pceTimerSetCallback() 
//! w肳Ă̂ pceIR ֌WׂĂłB
//! 
//! ԊOʐM̓G[̂ŁAĂMf[^
//! Ƃ͌܂BCRCɂƍsĂB
//! 
//! ܂ő̐ԊOM͋@\܂BpceIRStop() QƁB
//! 

void pceIRStartRxEx( unsigned char *pData, int len, int mode, int (*callback)(int rlen) )
{
	IRWK *piw = &irwk;

	ENTER_CS;

	piw->pData = pData;
	piw->len = len;
	piw->leader = 0x11;
	piw->end.rx = callback;

	pceIRStartRxPulse( mode, RxBit, 3000 );

	LEAVE_CS;
}


//!///// Piece Kernel Service API Reference
//! *v1.17
//!  pceIRStartRxPulse
//! 
//! ԊOŃpXPʂœ͂܂B
//! 
//! void pceIRStartRxPulse(
//! 		int mode,			// \ K0ɂĂ
//!			void (*rxproc)( int flag, unsigned short time ),
//!								// MR[obN֐
//! 		int timeout			// ^CAEgl (0 Ń^CAEg)
//! 		);
//! 
//! ߂lFȂ
//! 
//! wR[obN֐ŃpX̎Ms܂B
//!
//!  ^CAEg̎Ԃ͖0.67s(1.5MHz)PʂłB
//!@
//! flag 
//!  0   o
//!  1   o
//!  2   ^CAEgo (^CAEgw莞)
//!@
//! ̊eCxgӖ܂B
//! time ͐ΎԂłB0.67s(1.5MHz)PʂŁA0`65535 ͈̔͂
//! ܂B
//! 
//! R[obN̖߂l͂܂B
//! 
//! R[obN͊荞ݏ̓Ăяo܂̂
//! ӂĎgpĂBpceTimerSetCallback() QƁB
//! 
//! R[obNŎgpł API  pceTimerSetCallback() 
//! w肳Ă̂ pceIR ֌WׂĂłB
//! 
//! ɎŵȂM͌p܂̂ŁApceIRStop() 
//! Kvɉđ̐ԊOAPIĂяoē]ԂύXĂB
//! 
//! ܂ő̐ԊOM͋@\܂BpceIRStop() QƁB
//! 

void pceIRStartRxPulse( int mode, void (*rxproc)( int flag, unsigned short time ), int timeout )
{
	volatile unsigned char *bp = iop_c;
	volatile unsigned short *sp = iop_s;
	IRWK *piw = &irwk;

	ENTER_CS;

	piw->bcnt = 0;
	piw->pos = 0;
	piw->proc.rx = rxproc;
	piw->tocnt = timeout;

	bp[0x2dd] |= 0x10;		// P34  3.3V  d ON

	bp[0x2d9] |= 0x80;		// P27  1
	bp[0x2d8] &= ~0x80;		// P27  m[} o͂

	// 16bit^C}5 vp

	bp[0x14c] = 8+3;		// 16bit^C}5 NbN 1/16
	sp[0x81a8/2] = 65536-1;	// 16bit^C}5 RyAf[^A
	sp[0x81aa/2] = 65536-1;	// 16bit^C}5 RyAf[^B
	bp[0x81ae] = 7;			// 16bit^C}5 

	if ( timeout ) {
		bp[0x268] |= 0x70;	// 16bit^C}5 荞݃vCIeB
		bp[0x274] |= 0x80;	// 16bit^C}5 RyAf[^A 荞݋

		pceVectorSetTrap(51, irr2_isr); // 16bit^C}5 RyAf[^A 荞݃xN^
	}
	else {
		bp[0x274] &= ~0x80;	// 16bit^C}5 RyAf[^A 荞 OFF
	}

	// IRM 荞 =K52

	bp[0x2c6] |= 0x10;		// |[g2 ͑I
	bp[0x2c8] |= 0x04;		// |[g2 ɐI
	//bp[0x2c8] &= ~0x04;		// |[g2 ɐI
	//bp[0x2c9] |= 0x04;		// |[g2 GbW/xI
	bp[0x2c9] &= ~0x04;		// |[g2 GbW/xI

	bp[0x261] |= 0x07;		// |[g2 荞݃vCIeB
	bp[0x270] |= 0x04;		// |[g2 荞݋

	pceVectorSetTrap(18, irr_isr); // |[g2 荞݃xN^

	LEAVE_CS;
}


//!///// Piece Kernel Service API Reference
//! 
//!  pceIRStartTx
//! 
//! ԊOŃf[^PubNo͂܂B
//! 
//! void pceIRStartTx(
//! 		const unsigned char *pData,	// Mf[^̂obt@̃|C^
//! 		int len						// obt@(1`255)
//! 		);
//! 
//! ߂lFȂ
//! 
//! mode  0, callback  NULL Ƃ pceIRStartTxEx() ĂԂ̂ƓłB
//! 

void pceIRStartTx( const unsigned char *pData, int len )
{
	asm( "xld.w	%r14,0" );
	asm( "xld.w	%r15,0" );
	asm( "xjp	pceIRStartTxEx" );
}

//!///// Piece Kernel Service API Reference
//! *v1.17
//!  pceIRStartTxEx
//! 
//! ԊOŃf[^PubNo͂܂B
//! 
//! void pceIRStartTxEx(
//! 		const unsigned char *pData,	// Mf[^̂obt@̃|C^
//! 		int len,					// obt@(1`255)
//! 		int mode,					// \ K0ɂĂ
//! 		int (*callback)(void)		// IR[obN֐
//! 		);
//! 
//! ߂lFȂ
//! 
//! ͔񓯊֐łB͂ɖ߂܂B
//!
//! ͎̊̂Q̕@Œm邱Ƃo܂B
//!
//! * callback  NULL ̎
//! pceIRGetStat() ɂăXe[^XɂȂƂmF܂B
//! ̏ꍇAŎIɃftHg̑M~s܂B
//! 
//! * callback  NULL ȊO̎
//! w肳ꂽR[obN֐Ăяo邱ƂŊmF܂B
//! R[obN֐ 0 ԂꍇAIɃftHg
//! M~s܂B
//! 1 Ԃꍇ pceIRStop() Kvɉđ̐ԊOAPIĂяo
//! ]ԂύXĂB
//! 
//! R[obN͊荞ݏ̓Ăяo܂̂
//! ӂĎgpĂBpceTimerSetCallback() QƁB
//! 
//! R[obNŎgpł API  pceTimerSetCallback() 
//! w肳Ă̂ pceIR ֌WׂĂłB
//! 
//! ܂ő̐ԊOM͋@\܂BpceIRStop() QƁB
//! 

void pceIRStartTxEx( const unsigned char *pData, int len, int mode, int (*callback)(void) )
{
	IRWK *piw = &irwk;

	ENTER_CS;

	piw->pData = (unsigned char *)pData;
	piw->len = len;
	piw->leader = 0x11;
	piw->end.tx = callback;

	pceIRStartTxPulse( mode, TxBit );

	LEAVE_CS;
}


//!///// Piece Kernel Service API Reference
//! *v1.17
//!  pceIRStartTxPulse
//! 
//! ԊOŃpXPʂŏo͂܂B
//! 
//! void pceIRStartTxPulse(
//! 		int mode,					// \ K0ɂĂ
//! 		int (*txproc)( int flag )	// MR[obN֐
//! 		);
//! 
//! ߂lFȂ
//! 
//! wR[obN֐ŃpX̑Ms܂B
//!@
//! flag 
//!  0   ~
//!  1   Jn
//!@
//! ̊egKӖ܂B
//! 
//! ߂ĺÃgK܂ł̎Ԃ26.4s(37.9kHz)Pʂ
//! w肵܂B
//! 
//! R[obN͊荞ݏ̓Ăяo܂̂
//! ӂĎgpĂBpceTimerSetCallback() QƁB
//! 
//! R[obNŎgpł API  pceTimerSetCallback() 
//! w肳Ă̂ pceIR ֌WׂĂłB
//! 
//! ɎŵȂ著M͌p܂̂ŁApceIRStop() 
//! Kvɉđ̐ԊOAPIĂяoē]ԂύXĂB
//! 
//! ܂ő̐ԊOM͋@\܂BpceIRStop() QƁB
//! 

void pceIRStartTxPulse( int mode, int (*txproc)( int flag ) )
{
	volatile unsigned char *bp = iop_c;
	volatile unsigned short *sp = iop_s;
	IRWK *piw = &irwk;

	ENTER_CS;

	piw->tcnt = 1;
	piw->bcnt = 0;
	piw->pos = 0;
	piw->proc.tx = txproc;

//	bp[0x2dd] &= ~0x10;			// P34  0V  d OFF

	bp[0x2d9] |= 0x80;			// P27  1
	bp[0x2d8] &= ~0x80;			// P27  m[} o͂

	// IRMp P27  16bit^C}5 o͂, LA 38kHz

	bp[0x14c] = 8+0;			// 16bit^C}5 NbN 1/1
	sp[0x81a8/2] = IRCNT/2-1;	// 16bit^C}5 RyAf[^A
	sp[0x81aa/2] = IRCNT-1;		// 16bit^C}5 RyAf[^B
	bp[0x81ae] = 7;				// 16bit^C}5 

	bp[0x268] |= 0x70;			// 16bit^C}5 荞݃vCIeB
	bp[0x274] |= 0x80;			// 16bit^C}5 RyAf[^A 荞݋

	pceVectorSetTrap(51, irt_isr); // 16bit^C}5 RyAf[^A 荞݃xN^

	// IRM 荞 =K52

	bp[0x270] &= ~0x04;		// |[g2 荞 OFF

	LEAVE_CS;
}


//!///// Piece Kernel Service API Reference
//! 
//!  pceIRStop
//! 
//! ԊOʐM@\~܂B
//! 
//! void pceIRStop( void );
//! 
//! ߂lFȂ
//! 
//! ׂĂ̐ԊO֌W̃n[hEGA~܂B
//! Miҋ@jł΁A~iLZj܂B
//! 
//!  API 
//! pceIRStartRx(),pceIRStartRxEx(),pceIRStartRxPulse(),
//! pceIRStartTx(),pceIRStartTxEx(),pceIRStartTxPulse(),
//! ̊e API ݂͌ɔrIŁAȂԂłĂ
//! ŌɌĂяoꂽ API ̓ԂɂȂ܂B
//! 
//! 슮mFȂł̑ꍇAsSȃf[^
//! 󂯎肷邱ƂɂȂ܂B
//! 


void pceIRStop( void )
{
	volatile unsigned char *bp = iop_c;

	ENTER_CS;

	irwk.leader = 0;

	bp[0x2dd] &= ~0x10;		// P34  0V  d OFF

	// IRMp P27  16bit^C}5

	bp[0x14c] = 0;			// 16bit^C}5 NbN OFF
	bp[0x81ae] = 0;			// 16bit^C}5 
	bp[0x274] &= ~0x80;		// 16bit^C}5 RyAf[^A 荞 OFF

	bp[0x2d9] |= 0x80;		// P27  1
	bp[0x2d8] &= ~0x80;		// P27  m[} o͂

	// IRM 荞 =K52

	bp[0x270] &= ~0x04;		// |[g2 荞 OFF

	LEAVE_CS;
}


//!///// Piece Kernel Service API Reference
//! 
//!  pceIRGetStat
//! 
//! ԊOʐM󋵂擾܂
//! 
//! int pceIRGetStat( void );
//! 
//! ߂lF ==0  <>0 ʐM
//! 
//! pceIRStartTx() ܂ pceIRStartRx()ɂʐM
//! ǂ𒲂ׂ܂B
//! 

int pceIRGetStat( void )
{
	return irwk.leader & 0x10;
}


void InitIR( void )
{
//#ifndef __PCEKN__
//	memset( (void *)0x1000, 0, 0x100 );
//#endif
	pceVectorSetKs( KSNO_IRStartRx, pceIRStartRx );
	pceVectorSetKs( KSNO_IRStartTx, pceIRStartTx );
	pceVectorSetKs( KSNO_IRStartRxEx, pceIRStartRxEx );
	pceVectorSetKs( KSNO_IRStartTxEx, pceIRStartTxEx );
	pceVectorSetKs( KSNO_IRStartRxPulse, pceIRStartRxPulse );
	pceVectorSetKs( KSNO_IRStartTxPulse, pceIRStartTxPulse );
	pceVectorSetKs( KSNO_IRGetStat, pceIRGetStat );
	pceVectorSetKs( KSNO_IRStop, pceIRStop );
}



