
/////////////////////////////////////////////////////////////////////////////
//
//             /
//      -  P  /  E  C  E  -
//           /                 mobile equipment
//
//              System Programs
//
//
// PIECE KERNEL : Ver 1.00
//
// Copyright (C)2001 AUQAPLUS Co., Ltd. / OeRSTED, Inc. all rights reserved.
//
// Coded by MIO.H (OeRSTED)
//
// Comments:
//
//  {^̊ǗłB
//  n[ȟĂяȏAgK[o⃊s[gǗs܂B
//
//  v1.00 2001.11.09 MIO.H
//  v1.09 2001.11.30 MIO.H pcePadGetDirect tbN\API
//  v1.14 2001.12.21 MIO.H trigmode ύX last_trig  0 ɂ
//



#include <piece.h>
#include "pcekn.h"

static unsigned char trigmode;
static unsigned char last_trig;
static unsigned char first_trigc;
static unsigned char next_trigc;
static unsigned char trig_count;

//!///// Piece Kernel Service API Reference
//! 
//!  pcePadGetDirect
//! 
//! {^n[hEGA璼ړǂݍ݂܂B
//!
//! unsigned long pcePadGetDirect( void );
//!
//! ߂lF8rbg{^ON/OFFłB
//!         Ărbg 1 ɂȂ܂B
//!
//! ɁAړǂޕKvꍇ͂ĂяoȂ
//! pcePadGetProc(), pcePadGet() 𗘗pĂB
//!
//!
unsigned long _pcePadGetDirect( void )
{
	volatile unsigned char *bp = iop_c;
	unsigned long pad = (((bp[0x2c1]<<3) & 0xc0)|(bp[0x2c4] & 0x3f))^0xff;
//	if ( pad & (PAD_UP|PAD_DN) ) pad &= ~(PAD_LF|PAD_RI);
	return pad;
}

//!///// Piece Kernel Service API Reference
//! 
//!  pcePadGetProc
//! 
//! {^ǂݍ݂ƒIs܂B
//! 
//! void pcePadGetProc( void );
//!
//! ߂lFȂ
//!
//! {^n[hEGA璼ړǂݍ݁AɊi[܂B
//! ȑO̒lƔrAgK[pӂ܂B
//!
//! AvP[VEvV[W̍ԂɃVXeĂяoĂ
//! ̂ŁAɃ[UEAvP[VŌĂяoKv͂܂B
//!
void pcePadGetProc( void )
{
	unsigned char oldd = pad_data;
	unsigned char newd = pcePadGetDirect();
	unsigned char trig;

	pad_data = newd;
	trig = (oldd ^ newd) & newd;

	if ( trigmode ) {
		if ( trig ) {
			trig_count = first_trigc;
			last_trig = trig & ~(PAD_START | PAD_SELECT);
		}
		else if ( trig_count && oldd == newd ) {
			if ( !--trig_count ) {
				trig_count = next_trigc;
				trig = last_trig;
			}
			else {
				trig = 0;
			}
		}
		else {
			trig_count = 0;
			trig = 0;
		}
		//pad_trig = 0; //???
	}

	pad_trig = trig;
}


//!///// Piece Kernel Service API Reference
//!
//!  pcePadGet
//!
//! {^擾܂B
//!
//! unsigned long pcePadGet( void );
//!
//! ߂l : bit0-7  {^ON/FF (Ă 1)
//!          bit8-15 {^̃gK[ (Ă 1)
//!
//! pcePadGetProc()ɂ蓾ꂽ{^Ԃ܂B
//!
//! ʏ͂gpĂB
//! iVXeĂяojpcePadGetProc()ĂяoȂA
//! xĂяoĂl͕ς܂񂵁Ảe܂B
//! ipceAppProc() ł͂ƍlĂ悢łBj
//!
//! rbg蓖Ă̏ڍ
//!@
//!  #define PAD_RI 0x01
//!  #define PAD_LF 0x02
//!  #define PAD_DN 0x04
//!  #define PAD_UP 0x08
//!  #define PAD_B  0x10
//!  #define PAD_A  0x20
//!  #define PAD_D  0x40
//!  #define PAD_C  0x80
//!  
//!  #define TRG_RI 0x0100
//!  #define TRG_LF 0x0200
//!  #define TRG_DN 0x0400
//!  #define TRG_UP 0x0800
//!  #define TRG_B  0x1000
//!  #define TRG_A  0x2000
//!  #define TRG_D  0x4000
//!  #define TRG_C  0x8000
//!@
//!
unsigned long pcePadGet( void )
{
	return (pad_trig<<8) | pad_data;
}


//!///// Piece Kernel Service API Reference
//! 
//!  pcePadSetTrigMode
//! 
//! pbh̃gK[̃[hݒ肵܂B
//!
//! void pcePadSetTrigMode(
//!			int mode		// [h
//!			);
//!
//! ߂lFȂ
//!
//! mode ŎwłĺÂƂłB
//!
//! PP_MODE_SINGLE : s[gȂ
//! PP_MODE_REPEAT : s[g
//!
void pcePadSetTrigMode( int mode )
{
	last_trig = 0;
	trigmode = mode;
}


static int divnn( int a, int b )
{
	a /= b;
	a++;
	if ( !(a>>=1) ) a = 1;
	return a;
}


void setPadRepeatTime( void )
{
	first_trigc = divnn( 480*2, proc_period );
	next_trigc = divnn( 136*2, proc_period );
}


void InitPad( void )
{
	first_trigc = 3;
	next_trigc = 3;
	trig_count = 0;
	trigmode = 1;
	pceVectorSetKs(KSNO_PadGetDirect, _pcePadGetDirect);
	pceVectorSetKs(KSNO_PadGetProc, pcePadGetProc);
	pceVectorSetKs(KSNO_PadGet, pcePadGet);
	pceVectorSetKs(KSNO_PadSetTrigMode, pcePadSetTrigMode );
}


