
/////////////////////////////////////////////////////////////////////////////
//
//             /
//      -  P  /  E  C  E  -
//           /                 mobile equipment
//
//              System Programs
//
//
// PIECE KERNEL : Ver 1.00
//
// Copyright (C)2001 AUQAPLUS Co., Ltd. / OeRSTED, Inc. all rights reserved.
//
// Coded by MIO.H (OeRSTED)
//
// Comments:
//
//  v@\֘ȀłB
//
//  v1.00 2001.11.09 MIO.H
//  v1.03 2001.11.20 MIO.H  A[@\
//  v1.19 2003.02.14 N.SAWA pceTimeSetAlarm()ÃrbgԈႢC
//



#include <piece.h>
#include "pcekn.h"

static const unsigned short mtbl[12] = {
	0,
	31,
	31+28,
	31+28+31,
	31+28+31+30,
	31+28+31+30+31,
	31+28+31+30+31+30,
	31+28+31+30+31+30+31,
	31+28+31+30+31+30+31+31,
	31+28+31+30+31+30+31+31+30,
	31+28+31+30+31+30+31+31+30+31,
	31+28+31+30+31+30+31+31+30+31+30,
	//  2  3  4  5  6  7  8  9 10 11
};

static const unsigned short mtblu[12] = {
	0,
	31,
	31+29,
	31+29+31,
	31+29+31+30,
	31+29+31+30+31,
	31+29+31+30+31+30,
	31+29+31+30+31+30+31,
	31+29+31+30+31+30+31+31,
	31+29+31+30+31+30+31+31+30,
	31+29+31+30+31+30+31+31+30+31,
	31+29+31+30+31+30+31+31+30+31+30,
	//  2  3  4  5  6  7  8  9 10 11
};

static const unsigned short ytbl[4] = { 366, 365, 365, 365 };



static int ymd2sdate( int yy, int mm, int dd )
{
	int day;

	yy -= 2000;

	day = yy * 365;
	day += ( yy >> 2 );	// 邤N
	day += mtbl[mm-1];
	day += dd-1;
	if ( (yy & 3) || mm >= 3 ) day++;

	return day;
}


static void sdate2ymd( PCETIME *ptime, int n )
{
	int i, c;
	const unsigned short *mt = mtbl;

	for ( i = 2000; i < 2100; i++ ) {
		c = ytbl[i&3];
		if ( ( n -= c ) < 0 ) break;
	}
	n += c;
	ptime->yy = i;
	//printf( "(%d, %d)", i, n );
	if ( !(i & 3) ) mt = mtblu;
	for ( i = 1; i < 12; i++ ) {
		if ( n < mt[i] ) break;
	}
	n -= mt[i-1];
	ptime->mm = i;
	ptime->dd = n+1;
}



void alarm_isr( void )
{
	INT_BEGIN;
	{
		volatile unsigned char *bp = iop_c;
		int a;
		bp[0x287] &= ~2;	// 荞݃NA
		a = bp[0x152];
		if ( ((a>>2)&7) == 7 ) {
			a = 0xe0;
			bp[0x277] &= ~2;
		}
		a|=3;
		bp[0x152] = a;
		alarm_flag = a;
	}
	INT_END;
}





//!///// Piece Kernel Service API Reference
//! 
//!  pceTimeSet
//! 
//! RTCɎݒ܂
//!
//!	void pceTimeSet(
//!			const PCETIME *ptime	// ݒ肷鎞̍\̂̃AhX
//!			);
//!
//! ߂lFȂ
//! 
//! ӁFn[h̎dlɂ蕪͖܂B
//! ܂Ał̐ݒ肵ł܂B
//! 
//! ݒ\͈͂ 2000.1.1 ` 2099.12.31 ܂łłB
//! 
//! Q  pceTimeGet()
//! 
void pceTimeSet( const PCETIME *ptime )
{
	volatile unsigned char *bp = iop_c;
	int day = ymd2sdate( ptime->yy, ptime->mm, ptime->dd );

	ENTER_CS;
	bp[0x151] = 0x02;
	bp[0x155] = ptime->mi;
	bp[0x156] = ptime->hh;
	bp[0x157] = (unsigned char)(day);
	bp[0x158] = (unsigned char)(day >> 8);
	bp[0x151] = 0x01;
	LEAVE_CS;
}


//!///// Piece Kernel Service API Reference
//! 
//!  pceTimeGet
//! 
//! RTC玞擾܂
//!
//!	void pceTimeGet(
//!			PCETIME *ptime	// 擾鎞̍\̂̃AhX
//!			);
//!
//! ߂lFȂ
//! 
//! PCETIME \̂̓e
//!@
//! typedef struct tagPCETIME {
//! 	unsigned short yy;	// N
//! 	unsigned char mm;	// 
//! 	unsigned char dd;	// 
//! 	unsigned char hh;	// 
//! 	unsigned char mi;	// 
//! 	unsigned char ss;	// b
//! 	unsigned char s100;	// 1/100b
//! } PCETIME;
//!@
//! 
//! PCETIME \̂ s100 o[(1/100b)  1/100 b
//! x͂܂B
//! 
//! Q  pceTimeSet()
//! 
void pceTimeGet( PCETIME *ptime )
{
	volatile unsigned char *bp = iop_c;
	volatile unsigned long *wp = iop_w;
	unsigned long a,a2;
	int b, c;

	do {
		ENTER_CS;
		a = wp[0x154/4];
		b = bp[0x153];
		c = bp[0x158];
		a2 = wp[0x154/4];
		LEAVE_CS;
	} while ( a != a2 );

	ptime->s100 = ( ( b * 100 ) >> 8 );
	ptime->ss = (unsigned char)(a);
	ptime->mi = (unsigned char)(a>>8);
	ptime->hh = (unsigned char)(a>>16);
	c = (c<<8)+(a>>24);

	sdate2ymd( ptime, c );
}

//!///// Piece Kernel Service API Reference
//! *v1.03
//! 
//!  pceTimeSetAlarm
//! 
//! RTC ɃA[ݒ肵܂B
//!
//!	int pceTimeSetAlarm(
//!			const PCEALMTIME *ptime	// ݒ肷A[\̂̃|C^
//!			);
//!
//! ߂lF0 (ɐI)
//! 
//! RTC ɃA[ݒ肵܂B
//! ݒ肷ƁAw莞ɒʒm( pceAppNotify() ) ܂B
//! X^oCłċNāAʒm܂B
//! 
//! A[\ PCEALMTIME
//!@
//! typedef struct tagPCEALTIME {
//! 	unsigned long mode;		// A[샂[h
//! 	PCETIME time;			// ݒ肷鎞
//! } PCEALMTIME;
//!@
//! A[샂[h
//!@
//! ALM_STOP      : ~܂BA[ʒm͔܂B
//! 
//! ALM_EVERYDAY  : ɃA[ʒm܂
//!                 PCETIME time  hh, mi o[݂̂gp܂B
//! 
//! ALM_EVERYHOUR : ɃA[ʒm܂
//!                 PCETIME time  mi o[݂̂gp܂B
//! 
//! ALM_ONESHOT   : wɃA[ʒmx܂
//!                 PCETIME time ׂ̂Ăgp܂B
//!                 An[hEGA̐Ass, s100 ͖
//!                 ɊւẮA݂31ȓłȂƂ܂B
//!@
int pceTimeSetAlarm( const PCEALMTIME *palm )
{
	volatile unsigned char *bp = iop_c;

	ENTER_CS;

	bp[0x152] = 0xe3;		// v^C}荞ݐ䃌WX^

	bp[0x277] &= ~2;	// v^C}荞 ֎~
	bp[0x287] &= ~2;	// 荞݃NA

	if ( palm->mode ) {

		if ( palm->mode & 1 ) bp[0x159] = palm->time.mi;
		if ( palm->mode & 2 ) bp[0x15a] = palm->time.hh;
		if ( palm->mode & 4 ) { // 2003.02.14 N.SAWA
			int day = ymd2sdate( palm->time.yy, palm->time.mm, palm->time.dd );
			bp[0x15b] = (day & 31);
			alarm_dh = (day & ~31);
		}

		pceVectorSetTrap(65, alarm_isr);

		bp[0x26b] = 4;						// v^C}荞 vCIeB
		bp[0x152] = (0xe0|(palm->mode<<2));	// v^C}荞 vI
		bp[0x277] |= 2;						// v^C}荞 
	}

	LEAVE_CS;

	return 0;
}


//!///// Piece Kernel Service API Reference
//! *v1.03
//! 
//!  pceTimeGetAlarm
//! 
//! A[擾܂B
//!
//!	int pceTimeGetAlarm(
//!			PCEALMTIME *ptime	// 擾A[\̂̃|C^
//!			);
//!
//! ߂lF0 (ɐI)
//! 
//! RTC Ɍݐݒ肳ĂAA[擾܂B
//! 
//! 

int pceTimeGetAlarm( PCEALMTIME *palm )
{
	volatile unsigned char *bp = iop_c;

	ENTER_CS;

	palm->time.s100 = 0;
	palm->time.ss = 0;
	palm->time.mi = bp[0x159];
	palm->time.hh = bp[0x15a];

	sdate2ymd( &palm->time, alarm_dh + bp[0x15b] );

	palm->mode = ((bp[0x152]>>2)&7);

	LEAVE_CS;

	return 0;
}


void InitRTC( void )
{
	pceVectorSetKs(KSNO_TimeGet, pceTimeGet );
	pceVectorSetKs(KSNO_TimeSet, pceTimeSet );
	pceVectorSetKs(KSNO_TimeSetAlarm, pceTimeSetAlarm );
	pceVectorSetKs(KSNO_TimeGetAlarm, pceTimeGetAlarm );
}

