
/////////////////////////////////////////////////////////////////////////////
//
//             /
//      -  P  /  E  C  E  -
//           /                 mobile equipment
//
//              System Programs
//
//
// PIECE KERNEL : Ver 1.00
//
// Copyright (C)2001 AUQAPLUS Co., Ltd. / OeRSTED, Inc. all rights reserved.
//
// Coded by MIO.H (OeRSTED)
//
// Comments:
//
//  AvP[V̌ĂяoǗłB
//
//  v1.00 2001.11.09 MIO.H
//  v1.01 2001.11.10 MIO.H  SELECT+START(AvI) 0.5b
//  v1.03 2001.11.20 MIO.H  Heap/AlarmΉ
//  v1.06 2001.11.24 MIO.H  AvP[VSPwɑΉ
//  v1.13 2001.12.13 MIO.H  APPNF_EXITREQ  APPNR_REJECT ̏𐳂
//                          DMAgp halt g
//  v1.14 2001.12.21 MIO.H  pceAppExecFile gݍ
//  v1.17 2002.01.13 MIO.H  pceAppActiveResponse gݍ
//
//  v1.20 2004.05.03 Madoka MMCpexƎsǉ
//  v1.27 2005.03.13 Madoka MMCJ[lŏɍsǉ
//                          OpceAppNotifyŖ₢킹܂
//        2005.04.02 Madoka AvNMMĆAstartup.pexłĂ܂ƁA
//                          ƂĂdȂ̂ŁAstartup.pexłMMCȂ悤
//                          ɂ܂B
//        2005.04.02 Madoka VXej[Őݒ肷J[lMMCLtO
//                          ǉ܂B
//        2005.05.01 Madoka VXej[ɏIɂmmcExitĂ΂Ȃ悤ɂ
//                          B
//

#include <piece.h>
#include <string.h>
#include "pcekn.h"
#include "mmc_api.h"	//2005/03/13 Add by Madoka

//2005/04/02 Add by Madoka
extern unsigned char g_bMMCInitEnable;		//J[lMMCLtO

static const pceAPPHEAD built_in_app = {
	APPSIG,
	APPSYSVER,
	0,
	pceAppInit,
	pceAppProc,
	pceAppExit,
	pceAppNotify,
};


static pceAPPHEAD *search_app_sub( pceAPPHEAD *app )
{
	if ( app->signature == APPSIG ) return app;
#ifdef APPSIG_OLD
	if ( app->signature == APPSIG_OLD ) return app;
#endif
	return NULL;
}


static pceAPPHEAD *search_app( void )
{
	pceAPPHEAD *app;

	if ( !smf && pcePadGetDirect() != (PAD_SELECT|PAD_UP) ) {
		const char *fname = exec_fname;
		//2005/04/02 Add by Madoka startup.pexNꍇexec_fnameɂRs[
		if ( !*fname )
		{
			//R[h
		 	//fname = "startup.pex";
		 	strcpy(exec_fname,"startup.pex");	
		}	
		if ( (app = search_app_sub(APPSTARTPOS1))!=0 ) return app;
		if ( (app = search_app_sub(APPSTARTPOS2))!=0 ) return app;
		if ( !pceFileLoad( fname, NULL ) ) {
			if ( (app = search_app_sub(APPSTARTPOS1))!=0 ) return app;
			if ( (app = search_app_sub(APPSTARTPOS2))!=0 ) return app;
		}
	}

	if ( (app = search_app_sub((pceAPPHEAD *)&built_in_app))!=0 ) return app;

	return NULL;
}

//2004/05/03 Add by madoka
static pceAPPHEAD *search_mmc_app( void )
{
	pceAPPHEAD *app;
	
	if ( !smf && pcePadGetDirect() != (PAD_SELECT|PAD_UP) )
	{
		const char *fname = exec_fname;
		
		//NAvꍇ̓j[N
		//2005/04/02 Add by Madoka startup.pexNꍇexec_fnameɂRs[
		if ( !*fname )
		{
			//R[h
			//fname = "startup.pex";
			strcpy(exec_fname,"startup.pex");
		}
		if ( (app = search_app_sub(APPSTARTPOS1))!=0 ) return app;
		if ( (app = search_app_sub(APPSTARTPOS2))!=0 ) return app;
				
		//NAv̓ǂݍ݁SRAMWJ
		if (mmcFileLoad( fname ) == 0 )
		{
			if ( (app = search_app_sub(APPSTARTPOS1))!=0 ) return app;
			if ( (app = search_app_sub(APPSTARTPOS2))!=0 ) return app;
		}
		
	}

	//̂sꍇ̓j[N
	if ( (app = search_app_sub((pceAPPHEAD *)&built_in_app))!=0 ) return app;

	return NULL;
}

static int def_notify_proc( int type, int param )
{
	switch ( type ) {
		case APPNF_SMSTART:
		case APPNF_SMREQVBUF:
			return APPNR_REJECT;
		case APPNF_STANDBY:
		case APPNF_EXITREQ:
		case APPNF_SMRESUME:
		case APPNF_ALARM:
		case APPNF_INITMMC:		//2005/03/13 Add by Madoka
			return APPNR_ACCEPT;
	}
	return APPNR_IGNORE;
}


static int chk_notify( int type, int param )
{
	pceAPPHEAD *app = (pceAPPHEAD *)curapp;
	int ans = APPNR_IGNORE;

	if ( app->sysver >= VERSION(0,51) ) ans = app->notify_proc( type, param );
	if ( ans == APPNR_IGNORE ) ans = def_notify_proc( type, param );

	return ans;
}


//!///// Piece Kernel Service API Reference
//! 
//!  pceAppSetProcPeriod
//! 
//! AvP[VEvV[W̌ĂяoԊuݒ肵܂B
//! 
//! int pceAppSetProcPeriod(
//! 		int period		// Ԋu(msP) 1 ` 255
//! 		);
//! 
//! ߂lFȑO̐ݒl
//! 
//! period  INVALIDVAL w肷ƐVl͐ݒ肳܂B
//! ܂茻݂̐ݒlύXɎ擾邱Ƃo܂B
//!

int pceAppSetProcPeriod( int period )
{
	int old = proc_period;
	if ( period != INVALIDVAL ) {
		if ( period < 1 ) period = 1;
		if ( period > 255 ) period = 255;
		proc_period = (unsigned short)period;
		setPadRepeatTime();
	}
	return old;
}

//!///// Piece Kernel Service API Reference
//! 
//!  pceDebugSetMon
//! 
//! fobOEj^̐ݒs܂B
//! 
//! void pceDebugSetMon(
//! 		int mode	// fobOEj^̐ݒl
//! 		);
//! 
//! ߂lFȂ
//! 
//! ݒl̏ڍׂ͉L̂ƂłB
//! 
//! 0 Ȃ
//! 1 AChLED_
//! 
//! zAPI͊J@ސpłB
//!     iłł͈Ӗ܂B
//! 
void pceDebugSetMon( int mode )
{
}


//!///// Piece Kernel Service API Reference
//! 
//!  pceAppReqExit
//! 
//! AvP[V̏Iv܂B
//! 
//! void pceAppReqExit(
//! 		int exitcode	// IR[h
//! 		)
//! 
//! ߂lFȂ
//! 
void pceAppReqExit( int exitcode )
{
	appstat = 4;
	*exec_fname = 0;
}



//!///// Piece Kernel Service API Reference
//! *v1.14
//! 
//!  pceAppExecFile
//! 
//! t@Cw肵ăAvP[VN܂B
//! 
//! int pceAppExecFile(
//! 		const char *fname,	// t@C
//! 		int resv			// \(K0ɂĉ)
//! 		);
//! 
//! ߂lF 0
//! 
//! w肳ꂽt@CJ[lɕۑāAAvP[V
//! I܂BAPI pceAppReqExit() Ăяo܂̂
//! APIƂ͕ʂ pceAppReqExit() ĂяoĂ͂܂B
//! 
//! ۂɎw肵AvP[V[hA䂪ڂ̂
//! ĂяoAvP[VIłB
//!
//! t@C݂ȂAt@CȎst@C
//! ȂꍇAw肵AvP[V̋N͏o܂B
//! iAPIɂv͎s܂j
//!
//! ̏ꍇAstartup.pex N܂B݁A̎so
//! @͂܂B
//!

int pceAppExecFile( const char *fname, int resv )
{
	pceAppReqExit(0);
	strncpy(exec_fname, fname, sizeof(exec_fname));
	return 0;
}




//!///// Piece Kernel Service API Reference
//! *v1.17
//! 
//!  pceAppActiveResponse
//! 
//! AvP[VANeBuł邱ƂVXeɒʒm܂B
//! 
//! void pceAppActiveResponse(
//! 		int flag			// tO
//! 		);
//! 
//! ߂lFȂ
//! 
//! tOeŃANeBuł邱Ƃʒm܂B
//! 
//! EAAR_NOACTIVE (0)
//! 
//! ANeBuł͂܂B API ĂяoȂƂƓłB
//!
//! EAAR_ACTIVE (1)
//!
//! IɌĂяoƂŃAvP[VANeBuł邱ƂA
//! 삪ĂX^oCւ̈ڍs}ł܂B
//! 
//! X^oCւ̈ڍśApceAppNotify()ł̉ł}ł܂A
//! pceAppNotify() ̓X^oCvŏIiKŋۂ̂ɑ΂A
//!  API Ăяo@ɂ΁AX^oCv̂܂B
//! 
//! ΉȒPŕ֗łAՂɎgƃX^oCɓ炸dr
//! Q錋ʂɂȂ܂̂ŒӂĂB
//! 
//! Ƃ΁AԊOł̒ԒʐMȂǂŎgƂz肵Ă܂B
//! 
//! ĂяoȂ΁A̎_X^oCւ̌vn܂܂B
//! 

void pceAppActiveResponse( int flag )
{
	if ( flag == AAR_ACTIVE ) {
		if ( opetm_type == 3 ) opetm_type = 0;
	}
}


static void AppInit( void )
{
	pceAPPHEAD *app = (pceAPPHEAD *)curapp;

	app->signature = 0;
	pceAppSetProcPeriod( 80 );
	pceDebugSetMon(1);
	pceFontSetType(0);
	pceFontSetTxColor(3);
	pceFontSetBkColor(0);
	pcePadSetTrigMode(1);
	pceLCDSetOrientation(0);
	pceLCDSetBuffer( INVALIDLCDBUFFER );

	//2005/03/13 Add by Madoka
	//Ver.1.27J[lMMCɍs
	//悤ɕύX܂B
	//ɐꍇApceFilenAPItbN
	//AMMCΉ̃AvMMC̃t@C
	//߂悤ɂȂ܂B
	//
	//܂A]MP3vC[PMFvC[
	//ǂ́uMMCCuvMMCAv
	//̂߂ɁApceAppNotifyŃ[UAvMMC
	//₢킹悤ɂ܂B
	//
	//2005/04/02 Add by Madoka
	//startup.pexMMCĂ܂ƁAAC
	//R\悤ƂxMMCɃANZX
	//sĂƂĂdȂ̂ŁAstartup.pexł
	//MMCsȂ悤ɂ܂B
	//
	//܂AVXej[ŃJ[lMMC
	//̗L/ݒł悤ɂ܂B
	//g_bMMCInitEnable = 0̏ꍇMMCs
	//B
	{
		int nRet = chk_notify( APPNF_INITMMC, 0 );
		if((nRet == APPNR_ACCEPT) &&
		   (strcmp(exec_fname,"startup.pex") != 0) &&
		   (g_bMMCInitEnable == 1))
		{
			//MMC̏
			#define PEX_FILESIZE_MAX	(256)	//MMCŋNłpext@C̍őTCY(KB) 
			mmcInit(PEX_FILESIZE_MAX * 1024);
		}
	}
				
	app->initialize();
	appstat = 0;
	appcnt = 0;
	appstat = 2;
}


// appstat
//   0 : ~
//   1 : sJnv
//   2 : s
//   3 : sIv (I 0)
//   4 : sIv (I 1)
//   5 : sIv I5̂܂܂SRAM̃t@Cs2 2004/05/03 Add by Madoka
//
static void AppLoop( void )
{
	while ( 1 ) {
		{
			unsigned long a, n1;
			while ( 1 ) {
				n1 = ClockTicks;
				a = n1 - apptm_wk;
				if ( a >= proc_period ) break;
				//if ( ledck ) *(volatile unsigned char *)0x402d1 &= 0xd7; //LED ON
				if ( use_dma ) {
					pdwait(200);
				}
				else {
					asm( "halt" );
					asm( "nop" );
				}
				//if ( ledck ) *(volatile unsigned char *)0x402d1 |= 0x28; //LED OFF
			}
			apptm_wk = n1;
		}

		ProcUSB();
		pcePadGetProc();

		if ( !smf ) {
			unsigned long tm;
			int type = 0;

			{ // Ԃ̔
				int a = pcePadGet();
	
				if ( !a ) {
					if ( pows.status & 1 ) type = 3;
				} else if ( appstat == 2 ) {
					if ( a & TRG_START ) type = 1;
					else if ( a == (PAD_SELECT|PAD_START) ) {
						if ( opetm_type == 1 ) type = 1;
					}
					else if ( a == PAD_START ) type = 2;
				}

				if ( !type || type != opetm_type ) {
					opetm_type = type;
					opetm_wk = ClockTicks;
				}
			}

			tm = ClockTicks - opetm_wk;

			// I (SELECT+START) ̏
			if ( type == 1 && tm >= 500 ) {		// 0.5sec
				opetm_type = 0;
				pceAppReqExit(0);
			}
			
			// VXej[ (START Rb) ̏
			if ( type == 2 && tm >= 3000 ) {
				int n = chk_notify( APPNF_SMSTART, 0 );
				if ( n != APPNR_SUSPEND ) opetm_type = 0;
				if ( n == APPNR_ACCEPT ) {
					save_lcdbuff = lcdbuff;
					save_proc_period = proc_period;
					PushFontParameters();
					n = chk_notify( APPNF_SMREQVBUF, 0 );
					if ( n == APPNR_ACCEPT ) {
						smf = curapp;
						curapp = (unsigned long *)&built_in_app;
						biapp_init();
					}
				}
			}
			
			// X^oC (drdŖ 5) ̏
			if ( type == 3 && tm >= sbtm_limit ) {
				int n = chk_notify( APPNF_STANDBY, 0 );
				if ( n != APPNR_SUSPEND ) opetm_type = 0;
				if ( n == APPNR_ACCEPT ) {
					pcePowerEnterStandby(0);
				}
			}
		}

		if ( appstat >= 3 ) {
			int n = chk_notify(APPNF_EXITREQ, 0);
			if ( n == APPNR_ACCEPT ) {
				pceAPPHEAD *app = (pceAPPHEAD *)curapp;
				if ( app->sysver >= VERSION(0,22) && app->pre_terminate ) {
					app->pre_terminate();
				}
				
				//2005/03/13 Add by Madoka
				//AvIɂ͎MMCI
				//2005/05/01 Add by Madoka
				//VXej[ImmcExitĂ΂Ȃ
				//悤ɏCB
				if(curapp != (unsigned long *)&built_in_app)
				{
					mmcExit();
				}
				
				if ( smf ) {
					curapp = smf;
					smf = 0;
					appstat = 2;
					PopFontParameters();
					lcdbuff = save_lcdbuff;
					pceAppSetProcPeriod( save_proc_period );
					pceLCDTrans();
					chk_notify( APPNF_SMRESUME, 0 );
				}
				else {
					ResetHeap(0);
					
					//2004/05/16 Add by Madoka
					//MMC̋Nɂ͎Ԃ̂
					//ʂ͏Ȃł܂B
					//pceLCDDispStop();

					//2004/05/03 Add by madoka
                    //appstat5̏ꍇ(MMC̃t@Csv)	
					if(appstat == 5)
					{
						//appstat5̂܂܂ŏI
						return;
					}
					else
					{
						appstat = ( appstat == 4 );
						return;
					}

				}
			}
			else if ( n != APPNR_SUSPEND ) appstat = 2;
		}
			
		if ( appstat >= 2 ) {
			if ( alarm_flag ) {
				if ( chk_notify(APPNF_ALARM, 0) != APPNR_SUSPEND ) {
					alarm_flag = 0;
				}
			}
			
			if ( !pause_stat ) {
				pceAPPHEAD *app = (pceAPPHEAD *)curapp;
				pause_stat |= 2;
				app->periodic_proc( ++appcnt );
				pause_stat &= ~2;
			}
		}
	}
}


static unsigned char *InitHeapAndSP( void )
{
	pceAPPHEAD *app = (pceAPPHEAD *)curapp;
	unsigned char *sp = (unsigned char *)0x2000;
	unsigned char *heap = NULL;

	if ( app->sysver >= VERSION(1,0) ) {
		heap = app->bss_end;
		if ( app->stack_size ) {
			heap += ((app->stack_size + 3)&~3);
			sp = heap;
		}
	}
	
	if ( heap > system_info.sram_end ) {
		APIErr((unsigned long)heap,PCEKN_ERR_TOO_LARGE_APP);
	}

	ResetHeap( heap );

	return sp;
}



void AppStart( void )
{
//	*(volatile unsigned char *)0x402d1 |= 0x28; //LED OFF

	pceVectorSetKs(KSNO_AppSetProcPeriod, pceAppSetProcPeriod);
	pceVectorSetKs(KSNO_AppReqExit, pceAppReqExit);
	pceVectorSetKs(KSNO_AppExecFile, pceAppExecFile);
	pceVectorSetKs(KSNO_AppActiveResponse, pceAppActiveResponse);
	pceVectorSetKs(KSNO_DebugSetMon, pceDebugSetMon);
	pceVectorSetKs(KSNO_CRC32, pceCRC32);
	
	pceAppSetProcPeriod( 80 );

	pcePowerSetReport(PWR_RPTON);

	opetm_type = 1;
	opetm_wk = ClockTicks;
	sbtm_limit = 5*60*1000;	// 5

	apptm_wk = ClockTicks;

	appstat = 1;

	while ( 1 ) {
		asm( "xld.w %r9,0x2000" );
		asm( "ld.w %sp,%r9" );	// SP ݒ
		if ( appstat == 1 ) {
			ResetHeap( INITAPPEXTBUFF );
			curapp = (unsigned long *)search_app();
			InitHeapAndSP();
			asm( "ld.w %sp,%r10" );	// SP ݒ
			AppInit();
			AppLoop();
		}

		//2004/05/03 Add by Madoka
		//MMC̃t@Csꍇ
		if(appstat == 5)
		{
			appstat = 1;							//ʏ̒lɖ߂
			ResetHeap( INITAPPEXTBUFF - 0x2000 );	//ꎞIɃq[v𑝂₷(ꂪ炭EłB)
			curapp = (unsigned long *)search_mmc_app();
			ResetHeap( INITAPPEXTBUFF );			//{̗̈ɐݒ肵Ȃ
			InitHeapAndSP();
			asm( "ld.w %sp,%r10" );	// SP ݒ
			AppInit();
			AppLoop();
		}

	}

}



