
/////////////////////////////////////////////////////////////////////////////
//
//             /
//      -  P  /  E  C  E  -
//           /                 mobile equipment
//
//              System Programs
//
//
// PIECE KERNEL : Ver 1.00
//
// Copyright (C)2001-2002 AUQAPLUS Co., Ltd. / OeRSTED, Inc. all rights reserved.
//
// Coded by MIO.H (OeRSTED)
//
// Comments:
//
//  ^C}[ 1ms 荞݂ƁAɊ֘A鏈łB
//  PIECE ͂̊荞݂𓮍̊ƂĂ܂B
//
//  v1.00 2001.11.09 MIO.H
//  v1.07 2001.11.28 MIO.H xJE^@\
//  v1.17 2002.01.13 MIO.H ReLXgEXCb`[̃T|[g
//  v1.18 2002.01.16 MIO.H dlύX
//  v1.19 2003.02.24 N.SAWA pceTimerAdjustPrecisionCount()̕sC
//


#include <piece.h>
#include "pcekn.h"


unsigned long ClockTicks;

#define MAXTIMER 6

typedef struct tagTIMERWK {
	unsigned long cntwk;
	unsigned long cntwk0;
	void (*proc)( void );
} TIMERWK;

static TIMERWK timerwk[MAXTIMER];


void timer_sub(void)
{
	TIMERWK *pt = timerwk;
	do {
		if ( pt->cntwk ) {
			if ( !--(pt->cntwk) ) {
				pt->proc();
				pt->cntwk = pt->cntwk0;
			}
		}
	} while ( ++pt < timerwk + MAXTIMER );
}

void timer_isr(void)
{
	INT_BEGIN2;

	*(unsigned char *)0x40282 &= ~4;		// 荞݃NA

	if ( contextsw ) {
		asm( "xld.ub %r13,[snd_flg]" );		// NeBJEtO
		asm( "ld.w %r12,%sp" );				// ݂SP
		contextsw();
		asm( "ld.w %sp,%r10" );				// VSP
	}

	timer_sub();

	INT_END2;
}

#if 0
void t1hz_isr(void)
{
	INT_BEGIN;

	*(unsigned char *)0x40287 &= ~2;	// 荞݃NA

	*(unsigned char *)0x40152 = 0x63;

	INT_END;
}
#endif

//!///// Piece Kernel Service API Reference
//! 
//!  pceTimerSetCallback
//!
//! w莞Ԍo߂܂͊ԊuɂAĂяoR[obN֐o^܂B
//!
//! void pceTimerSetCallback(
//!			int ch,						// `l ( 0 ` 3 )
//!			int type,					// `(LQ)
//!			int time,					//  (ms)
//!			void (*callback)( void )	// ̃R[obN֐̃|C^
//!			);
//!
//! ߂lFȂ
//! 
//! x^C}[p̂߂APIłB
//!@
//! `
//!   PCE_TT_NONE       R[obN֐Ăяo܂B(time,callback͖)
//!   PCE_TT_ONESHOT    w莞ԌoߌA񂾂Ăяo܂
//!   PCE_TT_PERIODIC   wԊu̓xɌĂяo܂
//!@
//! in[hEGAj^C}[荞ݓ璼ڌĂяo܂B
//! ȉɗӂăvO~OĂB
//! 
//! E܂莞Ԃ₩ɖ߂
//! E荞݂Ȃ
//! EX^bNQȂ
//! EJ[lT[rXAPI₽ĂяoȂ
//!
//! R[obN֐ĂяoĂS API
//!
//! pceVectorSetTrap(), pceVectorSetKs(),
//! pceSystemGetInfo(),
//! pcePadGetDirect(), pcePadGet(),
//! pcePowerGetStatus(),
//!

void pceTimerSetCallback( int ch, int type, int time, void (*callback)( void ) )
{
	TIMERWK *pt = timerwk + ch;

	// ŏɂ 0 ɂ̂ŁA荞݋֎~sv
	pt->cntwk = 0;

	switch ( type ) {
		//case PCE_TT_NONE:
		//	break;
		case PCE_TT_ONESHOT:
			pt->proc = callback;
			pt->cntwk0 = 0;
			pt->cntwk = time;
			break;
		case PCE_TT_PERIODIC:
			pt->proc = callback;
			pt->cntwk0 = time;
			pt->cntwk = time;
			break;
	}
}



//!///// Piece Kernel Service API Reference
//! 
//!  pceTimerGetCount
//!
//! 1ms Pʂ̓JEgl𓾂܂B
//!
//! unsigned long pceTimerGetCount( void );
//!
//! ߂lFJEgl
//!
//! 1:
//!   1ms^C}[荞݂̃JEglł
//!   ɐΓIȐxł͂܂B
//!  iX^oCɂ̓JEg͐i݂܂Bj
//!  
//! 2:
//!   2^32 łP܂BAɂĖ49.7łB
//!  

unsigned long pceTimerGetCount( void )
{
	return ClockTicks;
}




//!///// Piece Kernel Service API Reference
//! *v1.07
//! 
//!  pceTimerGetPrecisionCount
//!
//! xJEgl𓾂܂B
//!
//! unsigned long pceTimerGetPrecisionCount( void );
//!
//! ߂lFxJEgl
//!
//!  1ʂ x̃JEgl擾܂B
//! [`̏Ԃ𒴍xɑ肷邱Ƃł܂B
//!
//! 1:
//!  ̖߂l̂܂ܗp邱Ƃ͂ł܂B
//!  pceTimerAdjustPrecisionCount() ŕϊĉB
//!  
//! 2:
//!   ɐΓIȐxł͂܂B
//!  iX^oCɂ̓JEg͐i݂܂Bj
//!  
//! 3:
//!    65b łP܂Bȏ̎Ԃ̑ɂ͎g܂B
//!  

void _pceTimerGetPrecisionCount( void )
{
	// ̂`oh̓\tgEGAOoRŌĂ΂܂
	asm("
		ld.w	%r10,[%sp+0]
		add		%sp,1
		ld.w	[%sp+0],%r10

_retry:
		xld.uh	%r4,[ClockTicks]
		xld.uh	%r5,[0x48184]
		xld.uh	%r6,[ClockTicks]

		cmp		%r4,%r6
		jrne	_retry

		ld.w	%r10,%r4
		xsll	%r10,16
		add		%r10,%r5

		reti
	");
}




//!///// Piece Kernel Service API Reference
//! *v1.07
//! 
//!  pceTimerAdjustPrecisionCount
//!
//! xJEg̎擾l𕪂ՂԂɒ܂B
//!
//! unsigned long pceTimerAdjustPrecisionCount(
//!			unsigned long st,	// JñJEgl
//!			unsigned long ed	// ĨJEgl
//!			);
//!
//! ߂lFʂPʂ̎
//!
//!  pceTimerGetPrecisionCount() œQ̃f[^̊Ԃ̎ԍ
//!  vZAʂPʂŎZo܂B
//!

#define TMCOUNTER 6000

unsigned long _pceTimerAdjustPrecisionCount( unsigned long st, unsigned long ed )
{
	int al = (ed&0xffff) - (st&0xffff);
	int ah = ((ed>>16) - (st>>16)) & 0xffff;	// 2003.02.24 N.SAWA

	if ( al < 0 ) {
		al += TMCOUNTER;
		ah--;
	}

	al *= 1000;
	al /= TMCOUNTER;

	return ah*1000 + al;
}



void nmi_isr( void )
{
	asm("
		pushn	%r1
		xld.w	%r1,ClockTicks
		ld.w	%r0,[%r1]
		add		%r0,1
		ld.w	[%r1],%r0
		popn	%r1
		reti
	");
}


//!///// Piece Kernel Service API Reference
//! *v1.17
//! 
//!  pceTimerSetContextSwitcher
//!
//! ReLXg؂ւ̏֐ݒ肵܂
//!
//! void pceTimerSetContextSwitcher(
//! 		unsigned long (*pContextSwitcher)( unsigned long nowsp, int flag )	// ReLXg؂ւ̏
//!			);
//!
//! ߂lFȂ
//!
//! ɂ}`Xbh邽߂̃ReLXg؂ւ
//! ߂̏֐ݒ肵܂B
//!
//! 1msbPʂ̃^C}[荞݃[`̒Ăяo܂B
//!
//!
//! P SP ؂ւɂReLXg؂ւ̎i񋟂݂̂
//! ̏ڍׂɂĂ̓VXe͈؊֗^܂B
//!
//! ؂ւ͏֐œK؂ɏĂB
//!
//! ReLXg؂ւ֐̎dl
//!@
//! unsigned long ContextSwitcher(
//! 		unsigned long nowsp,	// ݂ SP l
//!			int flag				// tO
//!			);
//!@
//! ߂lFV SP l
//!
//! flag ̓VXeԂɂ SP ύX̉ۂ܂B
//! ݎ̃rbggpĂ܂B
//!@
//!  PCE_TSCSF_INCRITICAL (1)  NeBJȏԂ SP ύXł܂
//!@
//! LtOZbgĂꍇVXe̓NeBJȏԂɂ
//! ߁ASP̕ύX nowsp ̂܂܎ă^[ĂB
//!
//! J[l̃\[XǂłƓ悤ɏΕύX邱Ƃ
//! \łA萫J[l̃o[WɈˑ̂łE߂܂B
//!
//! X^bNt[̍\
//!@
//! SP+0   ALR
//! SP+4   AHR
//! SP+8   R00
//! SP+12  R01
//! SP+16  R02
//! SP+20  R03
//! SP+24  R04
//! SP+28  R05
//! SP+32  R06
//! SP+36  R07
//! SP+40  R08
//! SP+44  R09
//! SP+48  R10
//! SP+52  R11
//! SP+56  R12
//! SP+60  R13
//! SP+64  R14
//! SP+68  R15
//! SP+72  PSR
//! SP+76  PC
//!@
//! pContextSwitcher  NULL w肷Ə֐͌ĂяoȂȂ܂B
//! AvP[VIɂ NULL w肵ĂB
//! ̏ꍇVXe̓ReLXgcł܂̂ŁAK؂ȃReLXg
//! ɖ߂ĂsĂB
//!

void pceTimerSetContextSwitcher( unsigned long (*pContextSwitcher)( unsigned long nowsp, int flag ) )
{
	contextsw = (void *)pContextSwitcher;
}



void InitTimer( void )
{
	volatile unsigned char *bp = iop_c;
	volatile unsigned short *sp = iop_s;

	pceVectorSetTrap(7, nmi_isr);
	pceVectorSetTrap(30, timer_isr);

	// ^C}荞

	bp[0x147] = 8+2;						// 16bit^C}0 NbN 1/6 (6MHz)
	sp[0x8180/2] = 100-1;					// 16bit^C}0 RyAf[^A
	sp[0x8182/2] = (TMCOUNTER*clkp1/4)-1;	// 16bit^C}0 RyAf[^B
	bp[0x8186] = 3;							// 16bit^C}0 

	bp[0x266] = 6;							// 16bit^C}0 荞݃vCIeB
	bp[0x272] = 4;							// 16bit^C}0 RyAf[^B 荞݋

	bp[0x170] = 0x80;		// EWD ݋
	bp[0x171] = 0x02;		// EIb`hbOL

//	pceVectorSetTrap(65, t1hz_isr);
	pceVectorSetKs(KSNO_TimerSetCallback, pceTimerSetCallback);
	pceVectorSetKs(KSNO_TimerGetCount, pceTimerGetCount);
	pceVectorSetKs(KSNO2_TimerGetPrecisionCount, _pceTimerGetPrecisionCount);
	pceVectorSetKs(KSNO_TimerAdjustPrecisionCount, _pceTimerAdjustPrecisionCount);
	pceVectorSetKs(KSNO_TimerSetContextSwitcher, pceTimerSetContextSwitcher);
}



