
/////////////////////////////////////////////////////////////////////////////
//
//             /
//      -  P  /  E  C  E  -
//           /                 mobile equipment
//
//              System Programs
//
//
// PIECE KERNEL : Ver 1.00
//
// Copyright (C)2001 AUQAPLUS Co., Ltd. / OeRSTED, Inc. all rights reserved.
//
// Coded by MIO.H (OeRSTED)
//
// Comments:
//
//  PCƂUSBɂʐM@\(USBCOM)̃T|[głB
//  ჌xȃANZX@\񋟂܂B
//
//  v1.00 2001.11.09 MIO.H
//  v1.01 2001.11.10 MIO.H  RTCݒR}hǉ
//  v1.02 2001.11.16 MIO.H  Screen ǂݏoǉ
//



#include <piece.h>
#include <string.h>
#include "pcekn.h"

#include "d12ci.h"



static unsigned char *memp;
static unsigned long mlen;
//static unsigned char mwr;

static unsigned char *usb_rp;
static const unsigned char *usb_wp;

typedef union tagUSBCOMSTAT {
	unsigned long l[3];
	unsigned char c[4];
} USBCOMSTAT;

static struct {
	USBCOMSTAT ucstat;
	USBCOMINFO info;
} usbi;

#define rxstat ucstat.c[0]
#define txstat ucstat.c[1]
#define mystat ucstat.c[2]
#define pcstat ucstat.c[3]

#define allstat ucstat.l[0]
#define usb_rcnt usbi.ucstat.l[1]
#define usb_wcnt usbi.ucstat.l[2]



static unsigned long readlong( unsigned char *p )
{
	return p[0] + ((p[1] + ((p[2] + (p[3] << 8)) << 8)) << 8);
}


static void go( unsigned long xadr )
{
	asm( "jp %r12" );
}


void txsub( void )
{
	if ( mlen /*&& mwr*/ ) {
		int len = 64;
		if ( len > mlen ) len = mlen;
		D12_WriteEndpoint(5, memp, len);
		memp += len;
		mlen -= len;
		if ( !mlen ) {
			int a = usbi.allstat;
			if ( a & UCS_TXING ) usbi.txstat = (UCS_TXDONE>>8);
		}
	}
}


void usbcom( char *p, int len )
{
	if ( mlen /*&& !mwr*/ ) {
		if ( len > mlen ) len = mlen;
		memcpy( memp, p, len );
		memp += len;
		mlen -= len;
		if ( !mlen ) {
			int a = usbi.allstat;
			if ( a & UCS_RXING ) usbi.rxstat = UCS_RXDONE;
		}
		return;
	}

	switch ( p[0] ) {

		case 0: // Version
			if ( len == 1 ) {
				D12_WriteEndpoint(5, (unsigned char *)&system_info, 8);
			}
			else if ( len == 2 ) {
				D12_WriteEndpoint(5, (unsigned char *)&system_info, p[1]);
			}
			break;

		case 1: // Execute
			if ( len == 5 ) {
				go( (unsigned long)readlong( p+1 ) );
			}
			break;

		case 2: // Read Cont.
			if ( len == 9 ) {
				memp = (unsigned char *)readlong( p+1 );
				mlen = readlong( p+5 );
				//mwr = 1;
				txsub();
			}
			break;

		case 3: // Write Cont.
			if ( len == 9 ) {
				memp = (unsigned char *)readlong( p+1 );
				mlen = readlong( p+5 );
				//mwr = 0;
			}
			break;

		case 4: // Set App Status.
			if ( len == 2 ) {
				if ( appstat == 0 && p[1] == 1 ) {
					appstat = 1;
				}
				else if ( appstat == 2 && p[1] == 3 ) {
					appstat = 3;
				}
			}
			break;

		// ȍ~ BIOS ver0.21 ȍ~Œǉ܂B

		case 5: // Get App Status.
			if ( len == 1 ) {
				D12_WriteEndpoint(5, (unsigned char *)&appstat, 2);
			}
			break;

		case 6: // Get Wave Buff Status.
			if ( len == 2 ) {
				static unsigned short a;
				a = pceWaveCheckBuffs( p[1] );
				D12_WriteEndpoint(5, (unsigned char *)&a, 2);
			}
			break;

		case 7: // Out Wave Data.
			if ( len == 6 ) {
				PCEWAVEINFO *pwi = (PCEWAVEINFO *)readlong( p+2 );
				pceWaveDataOut( p[1], pwi );
			}
			break;

		// ȍ~ BIOS ver0.31 ȍ~ŕύXEǉ܂B

		case 8: // FlashErase
			if ( len == 5 ) {
				int a = pceFlashErase( (void *)readlong(p+1) );
				D12_WriteEndpoint(5, (unsigned char *)&a, 2);
			}
			break;

		case 9: // FlashWrite
			if ( len == 13 ) {
				int a = pceFlashWrite( (void *)readlong(p+1), (void *)readlong(p+5), readlong(p+9) );
				D12_WriteEndpoint(5, (unsigned char *)&a, 2);
			}
			break;

		// ȍ~ BIOS ver0.49 ȍ~ŒǉEύX܂B

		case 10: // USBCOM Read
			if ( len == 1 ) {
				memp = (unsigned char *)usb_wp;
				mlen = usb_wcnt;
				//mwr = 1;
				usb_wcnt = 0;
				usbi.txstat = (UCS_TXING>>8);
				txsub();
			}
			break;

		case 11: // USBCOM Write
			if ( len == 1 ) {
				memp = usb_rp;
				mlen = usb_rcnt;
				//mwr = 0;
				usb_rcnt = 0;
				usbi.rxstat = UCS_RXING;
			}
			break;

		case 12: // USBCOM Get Stat.
			if ( len == 1 ) {
				D12_WriteEndpoint(5, (unsigned char *)&usbi.ucstat, sizeof(usbi.ucstat));
			}
			break;

		case 13: // USBCOM Open
			if ( len == 1 ) {
				usbi.pcstat = usbi.mystat;
				D12_WriteEndpoint(5, (unsigned char *)&usbi, sizeof(usbi));
			}
			break;

		case 14: // USBCOM Close
			if ( len == 1 ) {
				usbi.pcstat = 0;
				D12_WriteEndpoint(5, (unsigned char *)&usbi.pcstat, 1);
			}
			break;

		// ȍ~ BIOS ver1.01 ȍ~Œǉ܂B

		case 15: // Set RTC
			if ( len == 10 ) {
				pceTimeSet( (PCETIME *)(p+2) );
			}
			break;

		// ȍ~ BIOS ver1.02 ȍ~Œǉ܂B

		case 16: // App Pause
			if ( len == 2 ) {
				if ( p[1] ) pause_stat |= 1;
				else pause_stat &= ~1;
			}
			break;

		case 17: // LCDGetInfo
			if ( len == 1 ) {
				struct {
					unsigned char stat;
					unsigned char resv;
					unsigned short sizx;
					unsigned short sizy;
					unsigned short resv2;
					void *buff;
				} tmpd;
				tmpd.stat = (pause_stat == 1);
				tmpd.resv = 0;
				tmpd.sizx = 128;
				tmpd.sizy = 88;
				tmpd.resv2 = 0;
				tmpd.buff = lcdbuff;
				D12_WriteEndpoint(5, (unsigned char *)&tmpd, 12);
			}
			break;

		// ȍ~ BIOS ver1.03 ȍ~Œǉ܂B

		case 18: // Get Heap top.
			if ( len == 1 ) {
				D12_WriteEndpoint(5, (unsigned char *)&heaptop, 4);
			}
			break;

	}
}



//!///// Piece Kernel Service API Reference
//! 
//!  pceUSBCOMSetup
//! 
//! USBʐM@\gp邽߂̏܂
//! 
//! void pceUSBCOMSetup(
//! 		USBCOMINFO *puci	// ZbgAbv̂߂̏ւ̃|C^
//! 		);
//! 
//! ߂lFȂ
//! 
//!@
//! typedef struct tagUSBCOMINFO {
//! 	unsigned char signature[16]; // AvP[Vʗpf[^
//! } USBCOMINFO;
//!@
//! USBʐM@\gpȂAvP[VN
//! PĂяoĂB
//! 
//! 

void pceUSBCOMSetup( USBCOMINFO *puci )
{
	ENTER_CS;
	memset( &usbi, 0, sizeof(usbi) );
	usb_rcnt = 0;
	usb_wcnt = 0;
	usbi.mystat = 1;
	usbi.info = *puci;
	LEAVE_CS;
}

//!///// Piece Kernel Service API Reference
//! 
//!  pceUSBCOMStartRx
//! 
//! USB-IFf[^PubN͂܂B
//! 
//! void pceUSBCOMStartRx(
//! 		unsigned char *pData,	// f[^Eobt@̃|C^
//! 		int len					// f[^
//! 		);
//! 
//! ߂lFȂ
//! 
//! 񓯊̂߁Å֐Ăяoł͓͂͊
//! ܂BXe[^Xǂœ슮̊mFKvłB
//! 
//! 

void pceUSBCOMStartRx( unsigned char *pData, int len )
{
	if ( usbi.mystat ) {
		ENTER_CS;
		usb_rp = pData;
		usb_rcnt = len;
		usbi.rxstat = UCS_RXWAIT;
		LEAVE_CS;
	}
}


//!///// Piece Kernel Service API Reference
//! 
//!  pceUSBCOMStartTx
//! 
//! USB-IFŃf[^PubNo͂܂B
//!
//!	void pceUSBCOMStartTx(
//! 		const unsigned char *pData,		// f[^Eobt@̃|C^
//! 		int len							// f[^
//! 		);
//! 
//! ߂lFȂ
//! 
//! 񓯊̂߁Å֐Ăяoł͏o͂͊
//! ܂BXe[^Xǂœ슮̊mFKvłB
//! 
//! 

void pceUSBCOMStartTx( const unsigned char *pData, int len )
{
	if ( usbi.mystat ) {
		ENTER_CS;
		usb_wp = pData;
		usb_wcnt = len;
		usbi.txstat = (UCS_TXWAIT>>8);
		LEAVE_CS;
	}
}


//!///// Piece Kernel Service API Reference
//! 
//!  pceUSBCOMStop
//! 
//! USBʐM@\~܂B
//! 
//! void pceUSBCOMStop( void );
//! 
//! ߂lF 0  / 1 : s
//! 
//! pceUSBCOMSetup ɑΉ܂B USB ʐM̕KvȂ
//! ₩ɌĂяoĂB
//! 
//! 
//! 

int pceUSBCOMStop( void )
{
	if ( !usbi.pcstat ) {
		ENTER_CS;
		memset( &usbi, 0, sizeof(usbi) );
		usb_rcnt = 0;
		usb_wcnt = 0;
		LEAVE_CS;
		return 0;
	}
	return 1;
}


//!///// Piece Kernel Service API Reference
//! 
//!  pceUSBCOMGetStat
//! 
//! USBʐM󋵂擾܂
//! 
//! int pceUSBCOMGetStat( void );
//! 
//! ߂lF Xe[^X
//! 
//! Xe[^X́Aȉ̊erbg̘_ał
//!@
//!  UCS_TXWAIT : Mҋ@
//!  UCS_RXWAIT : Mҋ@
//!  UCS_TXING  : M
//!  UCS_RXING  : M
//!  UCS_TXDONE : M
//!  UCS_RXDONE : M
//!@

int pceUSBCOMGetStat( void )
{
	int a;
	ENTER_CS;
	a = usbi.allstat;
	if ( a & UCS_TXDONE ) usbi.txstat = 0;
	if ( a & UCS_RXDONE ) usbi.rxstat = 0;
	LEAVE_CS;
	return a;
}




void InitUSBCOM( void )
{
	pceVectorSetKs( KSNO_USBCOMSetup, pceUSBCOMSetup );
	pceVectorSetKs( KSNO_USBCOMStartRx, pceUSBCOMStartRx );
	pceVectorSetKs( KSNO_USBCOMStartTx, pceUSBCOMStartTx );
	pceVectorSetKs( KSNO_USBCOMStop, pceUSBCOMStop );
	pceVectorSetKs( KSNO_USBCOMGetStat, pceUSBCOMGetStat );
}




